unsigned short kp, set_time = 0, h, done, set_interval , oldstate = 0, temp = 0, flag;

// Keypad module connections
 char keypadPort at PORTD;
// End Keypad module connections
// LCD module connections

sbit LCD_RS at RB4_bit;
sbit LCD_EN at RB5_bit;
sbit LCD_D4 at RB0_bit;
sbit LCD_D5 at RB1_bit;
sbit LCD_D6 at RB2_bit;
sbit LCD_D7 at RB3_bit;

sbit LCD_RS_Direction at TRISB4_bit;
sbit LCD_EN_Direction at TRISB5_bit;
sbit LCD_D4_Direction at TRISB0_bit;
sbit LCD_D5_Direction at TRISB1_bit;
sbit LCD_D6_Direction at TRISB2_bit;
sbit LCD_D7_Direction at TRISB3_bit;
// End LCD module connections

 int keypad_module();
 int ascii2int(int);
 unsigned short read_ds1307(unsigned short);
 int BCD2Binary(int);
 int Binary2BCD(int);
 void write_ds1307(unsigned short ,unsigned short);
 int ArrayToInt(int array[]);
 unsigned char BCD2UpperCh(unsigned char);
 unsigned char BCD2LowerCh(unsigned char);
 void update_time();
 void set_time_module();
 void set_hours();
 void set_minutes();
 void set_seconds();
 
 //time and date variables
 int second;
 int minute;
 int hour;
 int hr;
 int day;
 int dday;
 int month;
 int year;
 int ap;
 int state;


//state is either 1 or 0
//1 indicates the time is set by the user
//0 indicates that the time hasn't been set yet
char text1[] = "00:00:00";
char text2[] = "00:00:00";
char set[] = "00";
int h_display[2];
void main()
{
  TRISC = 0x00;
  OPTION_REG = 0x07;
  TMR0 = 39;
  INTCON = 0xA0;

  Keypad_Init();                           // Initialize Keypad
  Lcd_Init();                              // Initialize LCD
  Lcd_Cmd(_LCD_CLEAR);                     // Clear display
  Lcd_Cmd(_LCD_CURSOR_OFF);                // Cursor off
  I2C1_Init(100000);

  state = 0;
  flag = 0;
  lcd_out(1,1,"TAP '*' 3 TIMES");
  lcd_out(2,1,"TO SET TIME");



  do
{
    //Instructions:
    //Press *  3 times to navigate to set time  and intervals
    //After time is set the interval page will appear
    //After setting intervals you will be navigated to main screen
    //In main screen, intervals will be shown.
    
        if(!done)
        {
          kp = keypad_module();       //scan for pressed key
          if(kp == 42)                //if star "*" is pressed
          {
              set_time++;
              if(set_time >= 3)
              {
                 done = 1;
                 lcd_cmd(_LCD_CLEAR);
                 lcd_out(1,1,"Set Current Time:");
              }
          }
        }
          switch(set_time)
          {
                case 3:         //set hours
                set_hours();
                break;

                case 4:         //set minutes
                set_minutes();
                break;
                
                case 5:
                set_seconds();  //set seconds
                break;
                
                case 6:
                done = 0;
                set_time = 0;
                lcd_cmd(_LCD_CLEAR);
                break;
          }
 }while(1);
}

void interrupt() 
{
  if(!done)

    TMR0 = 39;
    INTCON.T0IF = 0;
}



 unsigned short read_ds1307(unsigned short address)
{
  unsigned short r_data;
  delay_ms(250);
  I2C1_Start();
  I2C1_Wr(0xD0); //address 0x68 followed by direction bit (0 for write, 1 for read) 0x68 followed by 0 --> 0xD0
  I2C1_Wr(address);
  I2C1_Repeated_Start();
  I2C1_Wr(0xD1); //0x68 followed by 1 --> 0xD1
  r_data=I2C1_Rd(0);
  I2C1_Stop();
  return(r_data);
}

void write_ds1307(unsigned short address,unsigned short w_data)
{
  I2C1_Start(); // issue I2C start signal
  //address 0x68 followed by direction bit (0 for write, 1 for read) 0x68 followed by 0 --> 0xD0
  I2C1_Wr(0xD0); // send byte via I2C (device address + W)
  I2C1_Wr(address); // send byte (address of DS1307 location)
  I2C1_Wr(w_data); // send data (data to be written)
  I2C1_Stop(); // issue I2C stop signal
}

int BCD2Binary(int a)
{
   int r,t;
   t = a & 0x0F;
   r = t;
   a = 0xF0 & a;
   t = a >> 4;
   t = 0x0F & t;
   r = t*10 + r;
   return r;
}

int Binary2BCD(int a)
{
   int t1, t2;
   t1 = a%10;
   t1 = t1 & 0x0F;
   a = a/10;
   t2 = a%10;
   t2 = 0x0F & t2;
   t2 = t2 << 4;
   t2 = 0xF0 & t2;
   t1 = t1 | t2;
   return t1;
}

unsigned char BCD2UpperCh(unsigned char bcd)
{
  return ((bcd >> 4) + '0');
}


unsigned char BCD2LowerCh(unsigned char bcd)
{
  return ((bcd & 0x0F) + '0');
  }
void update_time()
{
      second = read_ds1307(0);
      minute = read_ds1307(1);
      hour   = read_ds1307(2);
      hr = hour & 0b00011111;
      ap = hour & 0b00100000;

      text1[0] = BCD2UpperCh(hr);
      text1[1] = BCD2LowerCh(hr);
      text1[3] = BCD2UpperCh(minute);
      text1[4] = BCD2LowerCh(minute);
      text1[6] = BCD2UpperCh(second);
      text1[7] = BCD2LowerCh(second);
      
       lcd_out(1,1,text1);        //Display time
      // delay_ms(300);

}


int keypad_module(){

    int    kp = 0;                                // Reset key code variable
    // Wait for key to be pressed and released
    do
    {
      // kp = Keypad_Key_Press();          // Store key code in kp variable
      kp = Keypad_Key_press();             // Store key code in kp variable
      delay_ms(200);                       // Debounce safety
    }
    while (!kp);
   // Prepare value for output, transform key to it's ASCII value

    switch (kp) {

      case  1: kp = 49; break; // 1
      case  2: kp = 50; break; // 2
      case  3: kp = 51; break; // 3
      case  5: kp = 52; break; // 4
      case  6: kp = 53; break; // 5
      case  7: kp = 54; break; // 6
      case  9: kp = 55; break; // 7
      case 10: kp = 56; break; // 8
      case 11: kp = 57; break; // 9
      case 13: kp = 42; break; // *
      case 14: kp = 48; break; // 0
      case 15: kp = 35; break; // #

    }
    return kp;
}
void set_hours()
{
     set_time++;
     lcd_out(2,1, text1);           //in hour setting
     lcd_out(2,1, "--");     //indicate we are setting hours
     kp = keypad_module();
     text1[0] = kp;

     lcd_chr(2,1,kp);     //display first digit of hours
     set[0] = kp;         //store value
     h_display[0] = kp;

     kp = keypad_module();//fetch second digit
     lcd_chr(2,2,kp);     //display second digit
     text1[1] = kp;
     set[1] = kp;         // store second value
     h_display[1] = kp;
     h_display[0] = ascii2int(h_display[0]);
     h_display[1] = ascii2int(h_display[1]);
     temp = ArrayToInt(h_display);

     //hour set
     hour = BCD2Binary(hour);
     hour = hour + temp;
     hour = Binary2BCD(hour);
    if((hour & 0x1F) >= 0x13)
    {
      hour = hour & 0b11100001;
      hour = hour ^ 0x20;
    }

    else if((hour & 0x1F) <= 0x00)
    {
      hour = hour | 0b00010010;
      hour = hour ^ 0x20;
    }
    write_ds1307(2, hour); //write hour
}

 void set_minutes()
 {
     lcd_out(2,1, text1);
     lcd_out(2,4, "--");
     kp = keypad_module();

     set_time++;
     lcd_chr(2,4,kp);     //display first digit of minutes
     set[0] = kp;         //store value
     h_display[0] = kp;

     kp = keypad_module();//fetch second digit
     lcd_chr(2,5,kp);     //display second digit
     set[1] = kp;         // store second value
     h_display[1] = kp;

     h_display[0] = ascii2int(h_display[0]);
     h_display[1] = ascii2int(h_display[1]);
     temp = ArrayToInt(h_display);

     minute = BCD2Binary(minute);
     minute = minute + temp;
     if(minute >= 60)
        minute = 0;
     if(minute < 0)
        minute = 59;
     minute = Binary2BCD(minute);
     write_ds1307(1, minute); //write min

}

void set_seconds()
{
    write_ds1307(0,0x00);     //Reset second to 0 sec. and start Oscillator
    set_time++;
}